local ZifnabsRelease="r191013a" 
local myname="ZifnabsCore"
local Me=CreateFrame("Frame",myname)
if not ZifnabsMod then ZifnabsMod={core=Me} else ZifnabsMod.core=Me end

ZifnabsDB={}
ZifnabsDBpC={}

local initialize=0
local C
local L
local db
local dbpc
local mod

local event={}
local unknown_events={}
local widget={}
local config_section=nil

Me:SetScript("OnEvent",function(this,event,arg1,arg2,arg3,arg4) Me:OnEvent(event,arg1,arg2,arg3,arg4) end)
Me:SetScript("OnUpdate",function(self,elapsed) Me:OnUpdate(self,elapsed) end)
Me:RegisterEvent("VARIABLES_LOADED")

BINDING_HEADER_ZIFNABS = "Zifnabs"
SLASH_ZIFNABS1 = "/z"
SlashCmdList["ZIFNABS"]=function (cmd) Me:SlashCommand(cmd) end

-- --------------------------------------------------------------------------------------
-- INITIALIZE phase 1: VARIABLES_LOADED
-- --------------------------------------------------------------------------------------
function Me:VARIABLES_LOADED() 
	if not ZifnabsDB.dbinit then ZifnabsDB.dbinit=time() end
	if not ZifnabsDBpC.dbinit or ZifnabsDBpC.dbinit<ZifnabsDB.dbinit then ZifnabsDBpC={dbinit=time()} end
	initialize=1 
end

-- --------------------------------------------------------------------------------------
-- ON UPDATE and initialize phase 2
-- --------------------------------------------------------------------------------------
function Me:OnUpdate(caller,elapsed)
	if initialize==2 then Me:OnEvent("ONUPDATE",elapsed)
	elseif initialize==1 and GetDefaultLanguage("player") and GetNumLanguages() then 		
		local fwinfo={framework="Zifnabs",release=ZifnabsRelease,L=ZifnabsL,db=ZifnabsDB,dbpc=ZifnabsDBpC,mod=ZifnabsMod,C=ZifnabsConstants}
		fwinfo.RETAIL=false
--		if (ShowingCloak or Me.CheckRetail)()=="RETAIL" then fwinfo.RETAIL=true end
--		if fwinfo.RETAIL then mod.f:Print("WoW RETAIL") else mod.f:Print("WoW CLASSIC") end
		C=fwinfo.C
		L=fwinfo.L
		db=fwinfo.db
		dbpc=fwinfo.dbpc
		mod=fwinfo.mod
		mod.f:Initialize(fwinfo)
		mod.ui:Initialize(fwinfo)
		fwinfo.frame=mod.ui:newFrame(myname.."Frame",80,32,UIParent,"CENTER","CENTER",0,200,{transparent=true,mainframe=true})
		mod.scheduler:Initialize(fwinfo)
		for name,fwmod in pairs(mod) do
			if name~="core" and name~="f" and name~="ui" and fwmod.Initialize then fwmod:Initialize(fwinfo) end
		end
		for name,fwmod in pairs(mod) do 
			if fwmod.PostInit then fwmod:PostInit() end
		end
		widget.config=mod.ui:newControlButton(1,myname.."_Config",{click=Me.Click,tt=L.msg.configure})
		widget.config:SetNormalTexture("Interface/AddOns/Zifnabs/Icons/Buttons/config.tga")
		initialize=2
		mod.f:PrintR(L.msg.initialized,{fw=fwinfo.framework,release=fwinfo.release})
	end
end
function Me:CheckRetail() return "RETAIL" end

-- --------------------------------------------------------------------------------------
-- ON EVENT
-- --------------------------------------------------------------------------------------
function Me:OnEvent(eventname,arg1,arg2,arg3,arg4)
	if eventname=="VARIABLES_LOADED" then Me:VARIABLES_LOADED()
	elseif event[eventname] then
		for fwmod,info in pairs(event[eventname]) do
			if info.active and info.method then 
				info.method(does_not_get_to_method,arg1,arg2,arg3,arg4) 
			end
		end
	elseif not unknown_events[eventname] then 
		mod.f:PrintR(L.msg.unknownevent,{event=eventname})
		unknown_events[eventname]=(unknown_events[eventname] or 0)+1
	end
end

-- --------------------------------------------------------------------------------------
-- REGISTER FOR EVENT
-- --------------------------------------------------------------------------------------
function Me:Register4Event(eventname,modname,method)
	if eventname~="ONUPDATE" and eventname~="TICK" then Me:RegisterEvent(eventname) end
	if not event[eventname] then event[eventname]={} end
	event[eventname][modname]={active=true,method=method}
	if not method then mod.f:Print("NO METHOD TO REGISTER FOR "..eventname..":"..modname,nil,nil,"ff0000") end
end

-- --------------------------------------------------------------------------------------
-- DE-REGISTER FOR EVENT
-- --------------------------------------------------------------------------------------
function Me:DeRegister4Event(eventname,modname)
	if event[eventname] and event[eventname][modname] then event[eventname][modname]=nil end
	local count=0
	for m,dummy in pairs(event[eventname]) do 
		if dummy~=nil then count=count+1 end
	end
	if count==0 then 
		event[eventname]=nil 
		if eventname~="ONUPDATE" and eventname~="TICK" then Me:DeRegisterEvent(eventname) end
	end
end

-- --------------------------------------------------------------------------------------
-- SLASH COMMANDS
-- --------------------------------------------------------------------------------------
function Me:SlashCommand(cmd,parm)
	local parse=mod.f:Split(cmd," ",2)
	cmd=string.upper(parse[1] or "")
	parm=parse[2]
	if cmd=="ACQ" and db.itsmemyself then
		local AQUIRETEXT="{rt4}Haus Kerlait{rt4} sucht wieder Mitglieder. Bei uns stehen Spielspaß, Freundlichkeit und Rollenspiel im Vordergrund, du kannst questen und quatschen in angenehmer Runde und auch mal nette RP-Events erleben. {rt6}Bei Interesse bitte anflüstern.{rt6}"
		SendChatMessage(AQUIRETEXT,"CHANNEL",nil,1)
	elseif cmd=="DEBUG" then
		mod.f:Print("No Debug available "..gibbetnich)
	elseif cmd=="SCHEDULE" and parm then 
		parse=mod.f:Split(parm," ",2)
		mod.scheduler:Remind(tonumber(parse[1]),parse[2])
	elseif cmd=="SCHEDULE" then
		mod.scheduler:list()
	elseif cmd=="RELOAD" then
		if string.upper(parm or "")=="RESETDB" then
			ZifnabsDB=nil
			ZifnabsDBpC=nil
		elseif L.emotor.cmd[string.upper(parm or "")] then db.emotor.cmd[string.upper(parm or "")]=nil
		elseif string.upper(parm or "")=="EMOTOR" then db.emotor.cmd={}
		end
		ReloadUI()
	elseif cmd~="" then 
		mod.emotor:Command(cmd,parm)
	end
end

-- --------------------------------------------------------------------------------------
-- CONFIG BUTTON
-- --------------------------------------------------------------------------------------
function Me:Click(button,parse)
	local action=parse[#parse]
	if action=="Config" and widget.cframe and widget.cframe:IsVisible() then action="Close" end
	if action=="Config" then
		if not widget.cframe then
			widget.cframe=mod.ui:newFrame(myname.."_CFrame",700,500,UIParent,"CENTER","CENTER",0,0,{})
			widget.ctitle=mod.ui:addText(myname.."_CFrame_Title",700,20,widget.cframe,"TOP","TOP",0,0,12,"CENTER","CENTER")
			widget.ctitle:SetText("Zifnabs "..ZifnabsRelease)
			widget.close=mod.ui:newButton(myname.."_CFrame_Close",20,16,widget.cframe,"TOPRIGHT","TOPRIGHT",-2,-2,{click=Me.Click,text="X"})
			widget.save=mod.ui:newButton(myname.."_CFrame_Save",80,16,widget.cframe,"BOTTOMLEFT","BOTTOMLEFT",2,20,{click=Me.Click,hide=true,text=L.word.save})
			widget.ignore=mod.ui:newButton(myname.."_CFrame_Ignore",80,16,widget.cframe,"BOTTOMLEFT","BOTTOMLEFT",2,4,{click=Me.Click,hide=true,text=L.word.ignore})

			widget.section={}
			local nr=1
			widget.section[nr]=mod.ui:newButton(myname.."_CFrame_Section_"..nr,100,16,widget.cframe,"TOPLEFT","TOPLEFT",2,12-16*nr,{click=Me.ConfigSection,text=L.config["global"]})
			widget.section[nr].section={nr=nr,mod=Me,frame=mod.ui:newFrame(myname.."_CFrame_global",600,484,widget.cframe,"TOPLEFT","TOPLEFT",100,-16,{hide=true})}
			for n,modname in ipairs(C.config) do
				if mod[modname].IdentifyConfigs then
					local frames=mod[modname]:IdentifyConfigs()
					for subn,caption in ipairs(frames) do
						nr=nr+1
						widget.section[nr]=mod.ui:newButton(myname.."_CFrame_Section_"..nr,100,16,widget.cframe,"TOPLEFT","TOPLEFT",2,12-16*nr,{click=Me.ConfigSection,text=caption})
						widget.section[nr].section={nr=nr,mod=mod[modname],frame=mod.ui:newFrame(myname.."_CFrame_"..modname.."_"..nr,600,484,widget.cframe,"TOPLEFT","TOPLEFT",100,-16,{hide=true})}
					end
				end
			end
		end
		Me:ConfigSection(widget.section[1])
		widget.cframe:Show()
	elseif action=="Close" or action=="Ignore" or action=="Save" then
		Me:HandleChanges(action)
	end
end

-- --------------------------------------------------------------------------------------
-- CONFIG SECTION BUTTON
-- --------------------------------------------------------------------------------------
function Me:ConfigSection(button)
	if not config_section or Me:HandleChanges() then
		if config_section then 
			config_section.frame:Hide() 
			config_section.button:Enable()
		end
		config_section=button.section
		config_section.button=button
		config_section.button:Disable()
		if config_section.mod.StartConfig then config_section.mod:StartConfig(config_section.frame) end
		config_section.frame:Show()
	end
end

-- --------------------------------------------------------------------------------------
-- HANDLE CHANGES
-- --------------------------------------------------------------------------------------
function Me:HandleChanges(action)
	local ok=(not config_section or not config_section.frame.unsaved_changes)
	if action=="Save" then 
		if not ok and config_section.mod.SaveConfig then ok=config_section.mod:SaveConfig(config_section.frame) end
	elseif action=="Ignore" then
		if config_section.mod.IgnoreConfig then ok=config_section.mod:IgnoreConfig(config_section.frame) end
	elseif not ok then 
		mod.f:Sound("Buzzer.mp3")
		config_section.frame:Hide()
		config_section.frame:Show()
	elseif action=="Close" then 
		widget.cframe:Hide() 
		if config_section then 
			config_section.button:Enable()
			config_section.frame:Hide() 
		end
		config_section=nil
	end
	if ok then
		widget.save:Hide()
		widget.ignore:Hide()
		if config_section then 
			config_section.frame.unsaved_changes=false 
			config_section.frame:Hide()
			config_section.frame:Show()
		end
	end
	return ok
end

-- --------------------------------------------------------------------------------------
-- START GLOBAL CONFIG
-- --------------------------------------------------------------------------------------
function Me:StartConfig(frame)
	if not widget.copyright then
		widget.copyright=mod.ui:addText(myname.."_CFrame_Copyright",600,40,frame,"BOTTOMRIGHT","BOTTOMRIGHT",-2,4,12,"RIGHT","BOTTOM")
		widget.copyright:SetText(L.msg.copyright)
	end
end

-- --------------------------------------------------------------------------------------
-- SET UNSAVED CHANGES
-- --------------------------------------------------------------------------------------
function Me:SetUnsavedChanges(set)
	config_section.frame.unsaved_changes=set
	if set then
		widget.save:Show()
		widget.ignore:Show()
	else
		widget.save:Hide()
		widget.ignore:Hide()
	end
end

-- --------------------------------------------------------------------------------------
-- SAVE GLOBAL CONFIG
-- --------------------------------------------------------------------------------------
function Me:SaveConfig(frame)
	return true
end

-- --------------------------------------------------------------------------------------
-- IGNORE GLOBAL CONFIG
-- --------------------------------------------------------------------------------------
function Me:IgnoreConfig(frame) return true end
